<?php
include_once('SOAP/Value.php');
include_once('soap/SoapObject.php');
include_once('soap/SoapAttachment.php');

class MoodleSoapString {
  

  function & cast(&$value) {
    $r = $value;
    return $r;
  } // cast()

  

  /* PUBLIC STATIC string */ function & deserialize(&$xmlStruct) {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('string'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->deserialize($xmlStruct);
        return $r;
      }
    
    if (PEAR::isError($v = SoapObject::castSimpleType('string', $xmlStruct, _SOAP_VALIDATE_INPUT))) {
      $r = new SOAP_Fault('error in message deserialization: '.$v->getMessage());
      return $r;
    }
    return $v;
  } // deserialize()

  /* PUBLIC STATIC SOAP_Value & */ function & serialize(&$obj, $resultName = '') {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('string'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->serialize($obj, $resultName);
        return $r;
      }
    
    if (PEAR::isError($v = SoapObject::castSimpleType('string', $obj, _SOAP_VALIDATE_OUTPUT))) {
      $r = new SOAP_Fault('error in message serialization: '.$v->getMessage());
      return $r;
    }
    $r = ($resultName ? new SOAP_Value($resultName, '{http://www.w3.org/2001/XMLSchema}string', $v) 
                        : $v);
    return $r;
  } // serialize()

} // class MoodleSoapString

class MoodleSoapCondition {
  var $expr;
  var $op;
  var $value;
  
  function MoodleSoapCondition(
        /* string */ 
        $expr,
        /* string */ 
        $op,
        /* string */ 
        $value) {
    $this->expr = $expr;
    $this->op = $op;
    $this->value = $value;
  } // MoodleSoapCondition()
  
  function & getInstance(
        /* string */ 
        $expr,
        /* string */ 
        $op,
        /* string */ 
        $value) {
        $r = null;
        if (PEAR::isError($expr)) $r = new SOAP_Fault($expr);
        if (PEAR::isError($op)) $r = new SOAP_Fault($op);
        if (PEAR::isError($value)) $r = new SOAP_Fault($value);
        if ($r == null) {
          $r = new MoodleSoapCondition($expr,$op,$value);
        }
        return $r;
  } // getInstance()

  

  function & cast(&$value) {
    if (PEAR::isError($value)) {
      return $value;
    }
    $params = array(
        'expr' => MoodleSoapString::cast($v = $value->getValue('expr')),
        'op' => MoodleSoapString::cast($v = $value->getValue('op')),
        'value' => MoodleSoapString::cast($v = $value->getValue('value'))
        );
    $r = new MoodleSoapCondition($params['expr'],$params['op'],$params['value']);
    return $r;
  } // cast()

  function & getExpr() {
    return $this->expr;
  } // & getExpr()
  
  function setExpr(&$expr) {
    $this->expr = $expr;
  } // setExpr()

  function & getOp() {
    return $this->op;
  } // & getOp()
  
  function setOp(&$op) {
    $this->op = $op;
  } // setOp()

  function & getValue() {
    return $this->value;
  } // & getValue()
  
  function setValue(&$value) {
    $this->value = $value;
  } // setValue()

  

  /* PUBLIC STATIC MoodleSoapCondition & */ function & deserialize(&$xmlStruct) {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('Condition'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->deserialize($xmlStruct);
        return $r;
      }
    if (!is_object($xmlStruct)) {
      $r = (_SOAP_VALIDATE_INPUT ? new SOAP_Fault('error in message deserialization: Condition expected, got "'.$xmlStruct.'" instead') : new MoodleSoapCondition(null, null, null));
      return $r;
    }
    if (_SOAP_VALIDATE_INPUT) {
      $require = array('expr', 'op', 'value');
      $keys    = array_flip($require);
      foreach($require AS $attr) {
        if (!isset($xmlStruct->$attr)) {
          $r = new SOAP_Fault('error in message deserialization (Condition): missing attribute "'.$attr.'"');
          return $r;
        }
      }
      foreach(array_keys(get_object_vars($xmlStruct)) AS $attr) {
        if (!array_key_exists($attr, $keys)) {
          $r = new SOAP_Fault('error in message deserialization (Condition): '.$attr.'" not allowed here');
          return $r;
        }
      }
    }
    $r = new MoodleSoapCondition(MoodleSoapString::deserialize(object_get_value('expr', $xmlStruct)), MoodleSoapString::deserialize(object_get_value('op', $xmlStruct)), MoodleSoapString::deserialize(object_get_value('value', $xmlStruct)));
    return $r;
  } // deserialize()

  /* PUBLIC STATIC SOAP_Value & */ function & serialize(&$obj, $resultName = '') {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('Condition'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->serialize($obj, $resultName);
        return $r;
      }
    if (!is_object($obj)) {
      if (_SOAP_VALIDATE_OUTPUT) {
        $r = new SOAP_Fault('error in message serialization: Condition expected, got "'.$obj.'" instead');
        return $r;
      }
      else {
        $r = new SOAP_Value($resultName, '{http://lms.hu-berlin.de/moodle/Schema}Condition', null);
        return $r;
      }
    }
    if (_SOAP_VALIDATE_OUTPUT) {
      $require = array('expr', 'op', 'value');
      $keys    = array_flip($require);
      foreach($require AS $attr) {
        if (!isset($obj->$attr)) {
          $r = new SOAP_Fault('error in message serialization (Condition): missing attribute "'.$attr.'"');
          return $r;
        }
      }
    }
    $r = new SOAP_Value($resultName, '{http://lms.hu-berlin.de/moodle/Schema}Condition',
                            array(MoodleSoapString::serialize(object_get_value('expr', $obj), 'expr'),
                                  MoodleSoapString::serialize(object_get_value('op', $obj), 'op'),
                                  MoodleSoapString::serialize(object_get_value('value', $obj), 'value'))
                          );
    return $r;
  } // serialize()

} // class MoodleSoapCondition

class MoodleSoapArrayOfCondition {
  var $array;
  
  function MoodleSoapArrayOfCondition(/* Condition[] */ $array) {
    $this->array = $array;
  } // MoodleSoapArrayOfCondition()
  
  function & getInstance(/* Condition[] */ $array) {
        if (PEAR::isError($array)) {
          $r = new SOAP_Fault($array);
        }
        else {
          $r = new MoodleSoapArrayOfCondition($array);
        }
        return $r;
  } // getInstance()

  

  function & cast(&$value) {
    $r = new MoodleSoapArrayOfCondition($value);
    return $r;
  } // cast()

  
  function & getArray() {
    return $this->array;
  } // getArray()

  function setArray(&$array) {
    $this->array = $array;
  } // setArray()
  

  /* PUBLIC STATIC MoodleSoapArrayOfCondition & */ function & deserialize(&$xmlStruct) {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('ArrayOfCondition'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->deserialize($xmlStruct);
        return $r;
      }
    
    if (!$xmlStruct) {
      return null;
    }
    if (!is_array($xmlStruct)) {
      $r = (_SOAP_VALIDATE_INPUT ? new SOAP_Fault('error in message deserialization: ArrayOfCondition expected, got "'.$xmlStruct.'" instead') : new MoodleSoapArrayOfCondition(null));
      return $r;
    }
    $values = array();
    for($i = 0, $c = count($xmlStruct); $i < $c; ++$i) {
      if (!PEAR::isError($v =& MoodleSoapCondition::deserialize($xmlStruct[$i])) || !_SOAP_VALIDATE_INPUT) {
        $values[] = $v;
      }
      else {
        $r = new SOAP_Fault('error in message deserialization: '.$v->getMessage());
        return $r;
      }
    }
    return $values;
    
  } // deserialize()

  /* PUBLIC STATIC SOAP_Value & */ function & serialize(&$obj, $resultName = '') {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('ArrayOfCondition'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->serialize($obj, $resultName);
        return $r;
      }
    
    if (!is_object($obj) || !isset($obj->array) || !is_array($obj->array)) {
      if (_SOAP_VALIDATE_OUTPUT) {
        $r = new SOAP_Fault('error in message serialization: ArrayOfCondition expected, got "'.$obj.'" instead');
        return $r;
      }
      else {
        $obj = new stdclass();
        $obj->array = array();
      }
    }
    $values = array();
    for($i = 0, $c = count($obj->array); $i < $c; ++$i) {
      if (!PEAR::isError($v =& MoodleSoapCondition::serialize($obj->array[$i])) || !_SOAP_VALIDATE_OUTPUT) {
        $values[] = $v;
      }
      else {
        $r = new SOAP_Fault('error in message serialization: '.$v->getMessage());
        return $r;
      }
    }
    $r = new SOAP_Value($resultName, '{http://lms.hu-berlin.de/moodle/Schema}ArrayOfCondition', $values);
    return $r;
  } // serialize()

} // class MoodleSoapArrayOfCondition

class MoodleSoapInt {
  

  function & cast(&$value) {
    $r = $value;
    return $r;
  } // cast()

  

  /* PUBLIC STATIC int */ function & deserialize(&$xmlStruct) {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('int'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->deserialize($xmlStruct);
        return $r;
      }
    
    if (PEAR::isError($v = SoapObject::castSimpleType('int', $xmlStruct, _SOAP_VALIDATE_INPUT))) {
      $r = new SOAP_Fault('error in message deserialization: '.$v->getMessage());
      return $r;
    }
    return $v;
  } // deserialize()

  /* PUBLIC STATIC SOAP_Value & */ function & serialize(&$obj, $resultName = '') {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('int'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->serialize($obj, $resultName);
        return $r;
      }
    
    if (PEAR::isError($v = SoapObject::castSimpleType('int', $obj, _SOAP_VALIDATE_OUTPUT))) {
      $r = new SOAP_Fault('error in message serialization: '.$v->getMessage());
      return $r;
    }
    $r = ($resultName ? new SOAP_Value($resultName, '{http://www.w3.org/2001/XMLSchema}int', $v) 
                        : $v);
    return $r;
  } // serialize()

} // class MoodleSoapInt

class MoodleSoapBoolean {
  

  function & cast(&$value) {
    $r = $value;
    return $r;
  } // cast()

  

  /* PUBLIC STATIC boolean */ function & deserialize(&$xmlStruct) {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('boolean'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->deserialize($xmlStruct);
        return $r;
      }
    
    if (PEAR::isError($v = SoapObject::castSimpleType('boolean', $xmlStruct, _SOAP_VALIDATE_INPUT))) {
      $r = new SOAP_Fault('error in message deserialization: '.$v->getMessage());
      return $r;
    }
    return $v;
  } // deserialize()

  /* PUBLIC STATIC SOAP_Value & */ function & serialize(&$obj, $resultName = '') {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('boolean'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->serialize($obj, $resultName);
        return $r;
      }
    
    if (PEAR::isError($v = SoapObject::castSimpleType('boolean', $obj, _SOAP_VALIDATE_OUTPUT))) {
      $r = new SOAP_Fault('error in message serialization: '.$v->getMessage());
      return $r;
    }
    $r = ($resultName ? new SOAP_Value($resultName, '{http://www.w3.org/2001/XMLSchema}boolean', $v) 
                        : $v);
    return $r;
  } // serialize()

} // class MoodleSoapBoolean

class MoodleSoapCourse {
  var $id;
  var $title;
  var $shortcut;
  var $summary;
  var $public;
  var $allowGuest;
  var $location;
  var $teachers;
  var $categoryId;
  var $categoryName;
  
  function MoodleSoapCourse(
        /* int */ 
        $id,
        /* string */ 
        $title,
        /* string */ 
        $shortcut,
        /* string */ 
        $summary,
        /* boolean */ 
        $public,
        /* boolean */ 
        $allowGuest,
        /* string */ 
        $location,
        /* string */ 
        $teachers, 
        /* int */ 
        $categoryId, 
        /* string */
        $categoryName) {
    $this->id = $id;
    $this->title = $title;
    $this->shortcut = $shortcut;
    $this->summary = $summary;
    $this->public = $public;
    $this->allowGuest = $allowGuest;
    $this->location = $location;
    $this->teachers = $teachers;
    $this->categoryId = $categoryId;
    $this->categoryName = $categoryName;
  } // MoodleSoapCourse()
  
  function & getInstance(
        /* int */ 
        $id,
        /* string */ 
        $title,
        /* string */ 
        $shortcut,
        /* string */ 
        $summary,
        /* boolean */ 
        $public,
        /* boolean */ 
        $allowGuest,
        /* string */ 
        $location,
        /* string */ 
        $teachers,
        /* int */ 
        $categoryId,
        /* string */
        $categoryName) {
        $r = null;
        if (PEAR::isError($id)) $r = new SOAP_Fault($id);
        if (PEAR::isError($title)) $r = new SOAP_Fault($title);
        if (PEAR::isError($shortcut)) $r = new SOAP_Fault($shortcut);
        if (PEAR::isError($summary)) $r = new SOAP_Fault($summary);
        if (PEAR::isError($public)) $r = new SOAP_Fault($public);
        if (PEAR::isError($allowGuest)) $r = new SOAP_Fault($allowGuest);
        if (PEAR::isError($location)) $r = new SOAP_Fault($location);
        if (PEAR::isError($teachers)) $r = new SOAP_Fault($teachers);
        if (PEAR::isError($categoryId)) $r = new SOAP_Fault($categoryId);
        if (PEAR::isError($categoryName)) $r = new SOAP_Fault($categoryName);
        if ($r == null) {
          $r = new MoodleSoapCourse($id,$title,$shortcut,$summary,$public,$allowGuest,$location,$teachers,$categoryId,$categoryName);
        }
        return $r;
  } // getInstance()

  

  function & cast(&$value) {
    if (PEAR::isError($value)) {
      return $value;
    }
    $params = array(
        'id' => MoodleSoapInt::cast($v = $value->getValue('id')),
        'title' => MoodleSoapString::cast($v = $value->getValue('title')),
        'shortcut' => MoodleSoapString::cast($v = $value->getValue('shortcut')),
        'summary' => MoodleSoapString::cast($v = $value->getValue('summary')),
        'public' => MoodleSoapBoolean::cast($v = $value->getValue('public')),
        'allowGuest' => MoodleSoapBoolean::cast($v = $value->getValue('allowGuest')),
        'location' => MoodleSoapString::cast($v = $value->getValue('location')),
        'teachers' => MoodleSoapString::cast($v = $value->getValue('teachers')),
        'categoryId' => MoodleSoapInt::cast($v = $value->getValue('categoryId')),
        'categoryName' => MoodleSoapString::cast($v = $value->getValue('categoryName'))
        );
    $r = new MoodleSoapCourse($params['id'],$params['title'],$params['shortcut'],$params['summary'],$params['public'],$params['allowGuest'],$params['location'],$params['teachers'],$params['categoryId'],$params['categoryName']);
    return $r;
  } // cast()

  function & getId() {
    return $this->id;
  } // & getId()
  
  function setId(&$id) {
    $this->id = $id;
  } // setId()

  function & getTitle() {
    return $this->title;
  } // & getTitle()
  
  function setTitle(&$title) {
    $this->title = $title;
  } // setTitle()

  function & getShortcut() {
    return $this->shortcut;
  } // & getShortcut()
  
  function setShortcut(&$shortcut) {
    $this->shortcut = $shortcut;
  } // setShortcut()

  function & getSummary() {
    return $this->summary;
  } // & getSummary()
  
  function setSummary(&$summary) {
    $this->summary = $summary;
  } // setSummary()

  function & getPublic() {
    return $this->public;
  } // & getPublic()
  
  function setPublic(&$public) {
    $this->public = $public;
  } // setPublic()

  function & getAllowGuest() {
    return $this->allowGuest;
  } // & getAllowGuest()
  
  function setAllowGuest(&$allowGuest) {
    $this->allowGuest = $allowGuest;
  } // setAllowGuest()

  function & getLocation() {
    return $this->location;
  } // & getLocation()
  
  function setLocation(&$location) {
    $this->location = $location;
  } // setLocation()

  function & getTeachers() {
    return $this->teachers;
  } // & getTeachers()
  
  function setTeachers(&$teachers) {
    $this->teachers = $teachers;
  } // setTeachers()

  function & getCategoryId() {
    return $this->categoryId;
  } // & getCategoryId()
  
  function setCategoryId(&$categoryId) {
    $this->categoryId = $categoryId;
  } // setCategoryId()

  function & getCategoryName() {
    return $this->categoryName;
  } // & getCategoryName()
  
  function setCategoryName(&$categoryName) {
    $this->categoryName = $categoryName;
  } // setCategoryName()
  
  /* PUBLIC STATIC MoodleSoapCourse & */ function & deserialize(&$xmlStruct) {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('Course'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->deserialize($xmlStruct);
        return $r;
      }
    if (!is_object($xmlStruct)) {
      $r = (_SOAP_VALIDATE_INPUT ? new SOAP_Fault('error in message deserialization: Course expected, got "'.$xmlStruct.'" instead') : new MoodleSoapCourse(null, null, null, null, null, null, null, null));
      return $r;
    }
    if (_SOAP_VALIDATE_INPUT) {
      $require = array('id', 'title', 'shortcut', 'summary', 'public', 'allowGuest', 'location', 'teachers', 'categoryId', 'categoryName');
      $keys    = array_flip($require);
      foreach($require AS $attr) {
        if (!isset($xmlStruct->$attr)) {
          $r = new SOAP_Fault('error in message deserialization (Course): missing attribute "'.$attr.'"');
          return $r;
        }
      }
      foreach(array_keys(get_object_vars($xmlStruct)) AS $attr) {
        if (!array_key_exists($attr, $keys)) {
          $r = new SOAP_Fault('error in message deserialization (Course): '.$attr.'" not allowed here');
          return $r;
        }
      }
    }
    $r = new MoodleSoapCourse(MoodleSoapInt::deserialize(object_get_value('id', $xmlStruct)), MoodleSoapString::deserialize(object_get_value('title', $xmlStruct)), MoodleSoapString::deserialize(object_get_value('shortcut', $xmlStruct)), MoodleSoapString::deserialize(object_get_value('summary', $xmlStruct)), MoodleSoapBoolean::deserialize(object_get_value('public', $xmlStruct)), MoodleSoapBoolean::deserialize(object_get_value('allowGuest', $xmlStruct)), MoodleSoapString::deserialize(object_get_value('location', $xmlStruct)), MoodleSoapString::deserialize(object_get_value('teachers', $xmlStruct)), MoodleSoapInt::deserialize(object_get_value('categoryId', $xmlStruct)), MoodleSoapString::deserialize(object_get_value('categoryName', $xmlStruct)));
    return $r;
  } // deserialize()

  /* PUBLIC STATIC SOAP_Value & */ function & serialize(&$obj, $resultName = '') {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('Course'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->serialize($obj, $resultName);
        return $r;
      }
    if (!is_object($obj)) {
      if (_SOAP_VALIDATE_OUTPUT) {
        $r = new SOAP_Fault('error in message serialization: Course expected, got "'.$obj.'" instead');
        return $r;
      }
      else {
        $r = new SOAP_Value($resultName, '{http://lms.hu-berlin.de/moodle/Schema}Course', null);
        return $r;
      }
    }
    if (_SOAP_VALIDATE_OUTPUT) {
      $require = array('id', 'title', 'shortcut', 'summary', 'public', 'allowGuest', 'location', 'teachers', 'categoryId', 'categoryName');
      $keys    = array_flip($require);
      foreach($require AS $attr) {
        if (!isset($obj->$attr)) {
          $r = new SOAP_Fault('error in message serialization (Course): missing attribute "'.$attr.'"');
          return $r;
        }
      }
    }
    $r = new SOAP_Value($resultName, '{http://lms.hu-berlin.de/moodle/Schema}Course',
                            array(MoodleSoapInt::serialize(object_get_value('id', $obj), 'id'),
                                  MoodleSoapString::serialize(object_get_value('title', $obj), 'title'),
                                  MoodleSoapString::serialize(object_get_value('shortcut', $obj), 'shortcut'),
                                  MoodleSoapString::serialize(object_get_value('summary', $obj), 'summary'),
                                  MoodleSoapBoolean::serialize(object_get_value('public', $obj), 'public'),
                                  MoodleSoapBoolean::serialize(object_get_value('allowGuest', $obj), 'allowGuest'),
                                  MoodleSoapString::serialize(object_get_value('location', $obj), 'location'),
                                  MoodleSoapString::serialize(object_get_value('teachers', $obj), 'teachers'),
                                  MoodleSoapInt::serialize(object_get_value('categoryId', $obj), 'categoryId'),
                                  MoodleSoapString::serialize(object_get_value('categoryName', $obj), 'categoryName'))
                          );
    return $r;
  } // serialize()

} // class MoodleSoapCourse

class MoodleSoapArrayOfCourse {
  var $array;
  
  function MoodleSoapArrayOfCourse(/* Course[] */ $array) {
    $this->array = $array;
  } // MoodleSoapArrayOfCourse()
  
  function & getInstance(/* Course[] */ $array) {
        if (PEAR::isError($array)) {
          $r = new SOAP_Fault($array);
        }
        else {
          $r = new MoodleSoapArrayOfCourse($array);
        }
        return $r;
  } // getInstance()

  

  function & cast(&$value) {
    $r = new MoodleSoapArrayOfCourse($value);
    return $r;
  } // cast()

  
  function & getArray() {
    return $this->array;
  } // getArray()

  function setArray(&$array) {
    $this->array = $array;
  } // setArray()
  

  /* PUBLIC STATIC MoodleSoapArrayOfCourse & */ function & deserialize(&$xmlStruct) {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('ArrayOfCourse'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->deserialize($xmlStruct);
        return $r;
      }
    
    if (!$xmlStruct) {
      return null;
    }
    if (!is_array($xmlStruct)) {
      $r = (_SOAP_VALIDATE_INPUT ? new SOAP_Fault('error in message deserialization: ArrayOfCourse expected, got "'.$xmlStruct.'" instead') : new MoodleSoapArrayOfCourse(null));
      return $r;
    }
    $values = array();
    for($i = 0, $c = count($xmlStruct); $i < $c; ++$i) {
      if (!PEAR::isError($v =& MoodleSoapCourse::deserialize($xmlStruct[$i])) || !_SOAP_VALIDATE_INPUT) {
        $values[] = $v;
      }
      else {
        $r = new SOAP_Fault('error in message deserialization: '.$v->getMessage());
        return $r;
      }
    }
    return $values;
    
  } // deserialize()

  /* PUBLIC STATIC SOAP_Value & */ function & serialize(&$obj, $resultName = '') {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('ArrayOfCourse'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->serialize($obj, $resultName);
        return $r;
      }
    
    if (!is_object($obj) || !isset($obj->array) || !is_array($obj->array)) {
      if (_SOAP_VALIDATE_OUTPUT) {
        $r = new SOAP_Fault('error in message serialization: ArrayOfCourse expected, got "'.$obj.'" instead');
        return $r;
      }
      else {
        $obj = new stdclass();
        $obj->array = array();
      }
    }
    $values = array();
    for($i = 0, $c = count($obj->array); $i < $c; ++$i) {
      if (!PEAR::isError($v =& MoodleSoapCourse::serialize($obj->array[$i])) || !_SOAP_VALIDATE_OUTPUT) {
        $values[] = $v;
      }
      else {
        $r = new SOAP_Fault('error in message serialization: '.$v->getMessage());
        return $r;
      }
    }
    $r = new SOAP_Value($resultName, '{http://lms.hu-berlin.de/moodle/Schema}ArrayOfCourse', $values);
    return $r;
  } // serialize()

} // class MoodleSoapArrayOfCourse

class MoodleSoapCategory {
  var $id;
  var $title;
  var $location;
  
  function MoodleSoapCategory(
        /* int */ 
        $id,
        /* string */ 
        $title,
        /* string */ 
        $location) {
    $this->id = $id;
    $this->title = $title;
    $this->location = $location;
  } // MoodleSoapCategory()
  
  function & getInstance(
        /* int */ 
        $id,
        /* string */ 
        $title,
        /* string */ 
        $location) {
        $r = null;
        if (PEAR::isError($id)) $r = new SOAP_Fault($id);
        if (PEAR::isError($title)) $r = new SOAP_Fault($title);
        if (PEAR::isError($location)) $r = new SOAP_Fault($location);
        if ($r == null) {
          $r = new MoodleSoapCategory($id,$title,$location);
        }
        return $r;
  } // getInstance()

  

  function & cast(&$value) {
    if (PEAR::isError($value)) {
      return $value;
    }
    $params = array(
        'id' => MoodleSoapInt::cast($v = $value->getValue('id')),
        'title' => MoodleSoapString::cast($v = $value->getValue('title')),
        'location' => MoodleSoapString::cast($v = $value->getValue('location'))
        );
    $r = new MoodleSoapCategory($params['id'],$params['title'],$params['location']);
    return $r;
  } // cast()

  function & getId() {
    return $this->id;
  } // & getId()
  
  function setId(&$id) {
    $this->id = $id;
  } // setId()

  function & getTitle() {
    return $this->title;
  } // & getTitle()
  
  function setTitle(&$title) {
    $this->title = $title;
  } // setTitle()

  function & getLocation() {
    return $this->location;
  } // & getLocation()
  
  function setLocation(&$location) {
    $this->location = $location;
  } // setLocation()

  

  /* PUBLIC STATIC MoodleSoapCategory & */ function & deserialize(&$xmlStruct) {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('Category'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->deserialize($xmlStruct);
        return $r;
      }
    if (!is_object($xmlStruct)) {
      $r = (_SOAP_VALIDATE_INPUT ? new SOAP_Fault('error in message deserialization: Category expected, got "'.$xmlStruct.'" instead') : new MoodleSoapCategory(null, null, null));
      return $r;
    }
    if (_SOAP_VALIDATE_INPUT) {
      $require = array('id', 'title', 'location');
      $keys    = array_flip($require);
      foreach($require AS $attr) {
        if (!isset($xmlStruct->$attr)) {
          $r = new SOAP_Fault('error in message deserialization (Category): missing attribute "'.$attr.'"');
          return $r;
        }
      }
      foreach(array_keys(get_object_vars($xmlStruct)) AS $attr) {
        if (!array_key_exists($attr, $keys)) {
          $r = new SOAP_Fault('error in message deserialization (Category): '.$attr.'" not allowed here');
          return $r;
        }
      }
    }
    $r = new MoodleSoapCategory(MoodleSoapInt::deserialize(object_get_value('id', $xmlStruct)), MoodleSoapString::deserialize(object_get_value('title', $xmlStruct)), MoodleSoapString::deserialize(object_get_value('location', $xmlStruct)));
    return $r;
  } // deserialize()

  /* PUBLIC STATIC SOAP_Value & */ function & serialize(&$obj, $resultName = '') {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('Category'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->serialize($obj, $resultName);
        return $r;
      }
    if (!is_object($obj)) {
      if (_SOAP_VALIDATE_OUTPUT) {
        $r = new SOAP_Fault('error in message serialization: Category expected, got "'.$obj.'" instead');
        return $r;
      }
      else {
        $r = new SOAP_Value($resultName, '{http://lms.hu-berlin.de/moodle/Schema}Category', null);
        return $r;
      }
    }
    if (_SOAP_VALIDATE_OUTPUT) {
      $require = array('id', 'title', 'location');
      $keys    = array_flip($require);
      foreach($require AS $attr) {
        if (!isset($obj->$attr)) {
          $r = new SOAP_Fault('error in message serialization (Category): missing attribute "'.$attr.'"');
          return $r;
        }
      }
    }
    $r = new SOAP_Value($resultName, '{http://lms.hu-berlin.de/moodle/Schema}Category',
                            array(MoodleSoapInt::serialize(object_get_value('id', $obj), 'id'),
                                  MoodleSoapString::serialize(object_get_value('title', $obj), 'title'),
                                  MoodleSoapString::serialize(object_get_value('location', $obj), 'location'))
                          );
    return $r;
  } // serialize()

} // class MoodleSoapCategory

class MoodleSoapArrayOfCategory {
  var $array;
  
  function MoodleSoapArrayOfCategory(/* Category[] */ $array) {
    $this->array = $array;
  } // MoodleSoapArrayOfCategory()
  
  function & getInstance(/* Category[] */ $array) {
        if (PEAR::isError($array)) {
          $r = new SOAP_Fault($array);
        }
        else {
          $r = new MoodleSoapArrayOfCategory($array);
        }
        return $r;
  } // getInstance()

  

  function & cast(&$value) {
    $r = new MoodleSoapArrayOfCategory($value);
    return $r;
  } // cast()

  
  function & getArray() {
    return $this->array;
  } // getArray()

  function setArray(&$array) {
    $this->array = $array;
  } // setArray()
  

  /* PUBLIC STATIC MoodleSoapArrayOfCategory & */ function & deserialize(&$xmlStruct) {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('ArrayOfCategory'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->deserialize($xmlStruct);
        return $r;
      }
    
    if (!$xmlStruct) {
      return null;
    }
    if (!is_array($xmlStruct)) {
      $r = (_SOAP_VALIDATE_INPUT ? new SOAP_Fault('error in message deserialization: ArrayOfCategory expected, got "'.$xmlStruct.'" instead') : new MoodleSoapArrayOfCategory(null));
      return $r;
    }
    $values = array();
    for($i = 0, $c = count($xmlStruct); $i < $c; ++$i) {
      if (!PEAR::isError($v =& MoodleSoapCategory::deserialize($xmlStruct[$i])) || !_SOAP_VALIDATE_INPUT) {
        $values[] = $v;
      }
      else {
        $r = new SOAP_Fault('error in message deserialization: '.$v->getMessage());
        return $r;
      }
    }
    return $values;
    
  } // deserialize()

  /* PUBLIC STATIC SOAP_Value & */ function & serialize(&$obj, $resultName = '') {
      if (PEAR::isError($ser = MoodleSoapSerializerFactory::getSerializer('ArrayOfCategory'))) {
        return $ser;
      }
      if (is_object($ser)) {
        $r = $ser->serialize($obj, $resultName);
        return $r;
      }
    
    if (!is_object($obj) || !isset($obj->array) || !is_array($obj->array)) {
      if (_SOAP_VALIDATE_OUTPUT) {
        $r = new SOAP_Fault('error in message serialization: ArrayOfCategory expected, got "'.$obj.'" instead');
        return $r;
      }
      else {
        $obj = new stdclass();
        $obj->array = array();
      }
    }
    $values = array();
    for($i = 0, $c = count($obj->array); $i < $c; ++$i) {
      if (!PEAR::isError($v =& MoodleSoapCategory::serialize($obj->array[$i])) || !_SOAP_VALIDATE_OUTPUT) {
        $values[] = $v;
      }
      else {
        $r = new SOAP_Fault('error in message serialization: '.$v->getMessage());
        return $r;
      }
    }
    $r = new SOAP_Value($resultName, '{http://lms.hu-berlin.de/moodle/Schema}ArrayOfCategory', $values);
    return $r;
  } // serialize()

} // class MoodleSoapArrayOfCategory

?>
