<?php
include_once ('soap/SoapClientProxy.php');
include_once ('soap/MoodleSoapClasses.php');
include_once ('soap/MoodleSoapSerializerFactory_Client.php');

class MoodleSoapClientStub extends SoapClientProxy {
  function MoodleSoapClientStub($endpoint = null, $proxyParams = null) {
    if ($endpoint == null) {
      $endpoint = 'http://lms2.cms.hu-berlin.de/ws/soap/?Moodle';
    }
    $this->SoapClientProxy($endpoint, $proxyParams);
  } // MoodleSoapClientStub()

  /**
    * Liste von Moodle-Kursen
    */
  function & getCourses(
    /* moodlexsd:ArrayOfCondition[] */
    $conditions) {
    $params = array(
      'conditions' => MoodleSoapArrayOfCondition::serialize($conditions, 'conditions')
    );
    $soapResult =& $this->_soapcall('getCourses', $params, array('namespace' => 'http://lms.hu-berlin.de/moodle', 'soapaction' => 'getCourses'));
    if (PEAR::isError($this->error)) {
      return $this->error;
    }
    
    $result =& MoodleSoapArrayOfCourse::deserialize($soapResult);
    
    return $result;
  } // getCourses()


  /**
    * Liste von Moodle Kategorien (HU Struktur hierarchisch)
    */
  function & getCategories(
    /* moodlexsd:ArrayOfCondition[] */
    $conditions) {
    $params = array(
      'conditions' => MoodleSoapArrayOfCondition::serialize($conditions, 'conditions')
    );
    $soapResult =& $this->_soapcall('getCategories', $params, array('namespace' => 'http://lms.hu-berlin.de/moodle', 'soapaction' => 'getCategories'));
    if (PEAR::isError($this->error)) {
      return $this->error;
    }
    
    $result =& MoodleSoapArrayOfCategory::deserialize($soapResult);
    
    return $result;
  } // getCategories()

} // class MoodleSoapClientStub
?>
