<?php
include_once('soap/MoodleSoapClientStub.php');
include_once('soap/SoapObject.php');
include_once('soap/SoapBinary.php');

class MoodleSoapClientTestForm {
  var $arrayOffsets, $formCache;

  
  function MoodleSoapClientTestForm() {
    $this->arrayOffsets = array();
    $this->formCache   = array();
  } // MoodleSoapClientTestForm()

  function evaluate() {
    $definedActions = array('getCourses','getCategories', '_NOACTION_');
    $action = null;
    foreach($definedActions AS $a) {
      if (array_key_exists('SUBMIT_'.$a, $_POST) && $_POST['SUBMIT_'.$a]) {
        $action = $a;
        break;
      }
    }
    
    $client   = null;
    $endpoint = (strpos ($_SERVER['SERVER_PROTOCOL'], 'HTTPS') === 0 ? 'https://' : 'http://').$_SERVER['HTTP_HOST'].str_replace('test.php', '?Moodle', $_SERVER['SCRIPT_NAME']);
    if (($use = array_get_value('serviceendpoint', $_POST))) {
      if ($use == 'example') {
        $endpoint .= (strpos($endpoint, '?') === false ? '?' : '&').'example=true';
      }
    }
    if (($alt = array_get_value('alt_endpoint', $_POST))) {
      $endpoint = $alt;
    }
    $requestStart = NULL; 
    switch ($action) {
      case 'getCourses':
        $client = new MoodleSoapClientStub($endpoint);
        $conditions = array ();
        $o = new SoapObject ();
        $o->array = $conditions;

        $params = array(
          'conditions' => $this->processFormValue($action.'_conditions')
        );
        $requestStart = microtime ();
        $result = $client->getCourses($params['conditions']);
        break;
      case 'getCategories':
        $client = new MoodleSoapClientStub($endpoint);
        $params = array(
          'conditions' => $this->processFormValue($action.'_conditions')
        );
        $requestStart = microtime ();
        $result = $client->getCategories($params['conditions']);
        break;
      default:
        break;
    }

    if ($client) {
      echo '<div style="position:fixed;top:1px;right:1px;border:1px solid #cc0000;z-index:10;padding:4px;background-color:#f5f5f5;">
        <a href="javascript:toggleDisplay(\'xmloutput\', true);" class="button">&nbsp;xml&nbsp;</a>&nbsp;
        <a href="#pagetop" onclick="toggleDisplay(\'\', false);" class="button">&nbsp;&#9650;&nbsp;</a>&nbsp;
      </div>';
      echo '<div class="outputpanel" id="xmloutput" style="display:'.($_POST['outputmode'] != 'php' ? 'block' : 'none').'"><div class="output" style="overflow:hidden;">
      <pre><b>Total time (including message serialization / deserialization):</b> '.timeDiff ($requestStart, microtime (), false).' s<br/><br/><b>REQUEST (HTTP/ XML):</b><br/><br/>'.htmlspecialchars($client->getLastRequest()).'
<b>RESULT (HTTP/ XML):</b><br/><br/>'.htmlspecialchars(str_replace('><', ">\n<", $client->getLastResponse())).'</pre>
</div></div>';
    }
  } // evaluate()

  function printForm() {
    echo '<form name="soaptestform" method="post" enctype="multipart/form-data" action="'.$_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING'].'">
  <h1><i>Moodle</i> Soap Service Test Suite</h1>
  <b>Service Endpoint: </b><select size="1" name="serviceendpoint">
    <option value="default">Moodle</option>
    <option value="example"'; if (array_get_value('serviceendpoint', $_POST) == 'example') echo ' selected="selected"'; echo '>Example Callback</option>
  </select>&nbsp;&nbsp;
  <b>Alt.: </b><input type="text" name="alt_endpoint" size="48" value="'; echo array_get_value('alt_endpoint', $_POST); echo '" />&nbsp;<a href="javascript:clearEndpoint();" style="font-size:18px;color:#cc0000;text-decoration:none;">&nbsp;x&nbsp;</a>
  <hr size="1" />
  <input type="hidden" name="status_getCourses" value="'.array_get_value('status_getCourses', $_POST).'" />
  <div style="display:inline;float:left;">
  <a id="hide_getCourses" href="javascript:hide(\'getCourses\');" class="button" style="'.(array_get_value('status_getCourses', $_POST) ? '' : 'display:none;').'">&nbsp;&#8662;&nbsp;</a>
  <a id="show_getCourses" href="javascript:show(\'getCourses\');" class="button" style="'.(array_get_value('status_getCourses', $_POST) ? 'display:none;' : '').'">&nbsp;&#8664;&nbsp;</a>
  &nbsp;
  </div>
  <h2>getCourses</h2><span class="comment">Liste von Moodle-Kursen</span>
  <div id="panel_getCourses" style="'.(array_get_value('status_getCourses', $_POST) ? '' : 'display:none;').'">
  <table>
<tr>
      <td colspan="2"><span class="type">ArrayOfCondition</span> conditions</td>
    </tr>
    <tr><td colspan="2">
        <div id="getCourses_conditions_source" style="display:none;"><div class="shift" style="float:left;"><a href="javascript:deleteEntry(%22getCourses_conditions_-1%22);"  style="font-size:18px;color:#cc0000;text-decoration:none;">&nbsp;x&nbsp;</a></div><table><!-- array:conditions --><tr>
      <td colspan="2"><span class="type">Condition</span> conditions</td>
    </tr>
    <tr>
      <td colspan="2"><table class="shift" width="100%"><!-- sequence:conditions --><tr>
      <td><span class="type">string</span> expr</td>
      <td>
          <input type="text" value="" name="getCourses_conditions_-1_expr" />
          
      </td>
    </tr>
<tr>
      <td><span class="type">string</span> op</td>
      <td>
          <input type="text" value="" name="getCourses_conditions_-1_op" />
          
      </td>
    </tr>
<tr>
      <td><span class="type">string</span> value</td>
      <td>
          <input type="text" value="" name="getCourses_conditions_-1_value" />
          
      </td>
    </tr>
<!-- /sequence:conditions --></table></td>
    
    </tr>
<!-- /array:conditions --></table></div>
        <div id="getCourses_conditions_copy"></div><div class="shift">
  <a href="javascript:copy(%22getCourses_conditions%22);" class="button">&nbsp;+&nbsp;</a> conditions</div></td>
    </tr>

  </table><br/>
  <input type="submit" name="SUBMIT_getCourses" value="getCourses&#8227;" />
  </div>
  <hr size="1" />
  <input type="hidden" name="status_getCategories" value="'.array_get_value('status_getCategories', $_POST).'" />
  <div style="display:inline;float:left;">
  <a id="hide_getCategories" href="javascript:hide(\'getCategories\');" class="button" style="'.(array_get_value('status_getCategories', $_POST) ? '' : 'display:none;').'">&nbsp;&#8662;&nbsp;</a>
  <a id="show_getCategories" href="javascript:show(\'getCategories\');" class="button" style="'.(array_get_value('status_getCategories', $_POST) ? 'display:none;' : '').'">&nbsp;&#8664;&nbsp;</a>
  &nbsp;
  </div>
  <h2>getCategories</h2><span class="comment">Liste von Moodle Kategorien (HU Struktur hierarchisch)</span>
  <div id="panel_getCategories" style="'.(array_get_value('status_getCategories', $_POST) ? '' : 'display:none;').'">
  <table>
<tr>
      <td colspan="2"><span class="type">ArrayOfCondition</span> conditions</td>
    </tr>
    <tr><td colspan="2">
        <div id="getCategories_conditions_source" style="display:none;"><div class="shift" style="float:left;"><a href="javascript:deleteEntry(%22getCategories_conditions_-1%22);"  style="font-size:18px;color:#cc0000;text-decoration:none;">&nbsp;x&nbsp;</a></div><table><!-- array:conditions --><tr>
      <td colspan="2"><span class="type">Condition</span> conditions</td>
    </tr>
    <tr>
      <td colspan="2"><table class="shift" width="100%"><!-- sequence:conditions --><tr>
      <td><span class="type">string</span> expr</td>
      <td>
          <input type="text" value="" name="getCategories_conditions_-1_expr" />
          
      </td>
    </tr>
<tr>
      <td><span class="type">string</span> op</td>
      <td>
          <input type="text" value="" name="getCategories_conditions_-1_op" />
          
      </td>
    </tr>
<tr>
      <td><span class="type">string</span> value</td>
      <td>
          <input type="text" value="" name="getCategories_conditions_-1_value" />
          
      </td>
    </tr>
<!-- /sequence:conditions --></table></td>
    
    </tr>
<!-- /array:conditions --></table></div>
        <div id="getCategories_conditions_copy"></div><div class="shift">
  <a href="javascript:copy(%22getCategories_conditions%22);" class="button">&nbsp;+&nbsp;</a> conditions</div></td>
    </tr>

  </table><br/>
  <input type="submit" name="SUBMIT_getCategories" value="getCategories&#8227;" />
  </div>
  <hr size="1" />
  </form>';
  } // printForm()

  function restoreFormArrays() {
    $input = array();
    foreach(array_keys($_POST) as $key) {
      $input[ereg_replace('_[0-9]*$', '', ereg_replace('_-1.*$', '', $key))] = true;
    }
    $input = array_keys($input);
    sort($input);
    
    foreach($input AS $key) {
      $arrName = $this->arrayName($key);
      if ($this->isArray($arrName)) {
        $i = -1;
        while($this->array_scan($arrName.'_'.(++$i), $_POST, false, true) !== false) {
          echo '
    <script language="JavaScript" type="text/javascript">
      copy("'.$arrName.'");
    </script>';
        }
      }
    }
  } // restoreFormArrays()

  function restoreFormValues() {
    echo '<script language="JavaScript" type="text/javascript">';
    foreach($_POST AS $key => $value) {
      echo '
      if ((e = document.forms.soaptestform.elements[\''.$key.'\'])) {
        if (e.type == \'text\') {
          e.value = \''.$value.'\';
        }
      }
      ';
    } 
    echo '</script>';
  } // restoreFormValues()

  function processFormValue($elementName) {
    $result = null;
    if (!array_key_exists($elementName, $this->formCache)) {
      if ($this->isArray($elementName)) {
        // array
        $i      = -1;
        $values = array();
        $skip   = array();
        while($this->array_scan($elementName.'_'.(++$i), $_POST, false, true) !== false) {
          $skip[$elementName.'_'.$i] = true;
          $values[] = $this->processFormValue($elementName.'_'.$i);
        }
        $i      = -1;
        while($this->array_scan($elementName.'_'.(++$i), $_FILES, false, true) !== false) {
          if (!array_key_exists($elementName.'_'.$i, $skip)) {
            if (!PEAR::isError($e = $this->processFormValue($elementName.'_'.$i))) {
              $values[] = $e;
            }
          }
        }
        $result = new SoapObject(array('array' => $values));
      }
      elseif ($this->isSequence($elementName)) {
        // sequence
        $elements = array();
        $childrenKeys = array_merge(
          $this->array_scan($elementName.'_[^0-9][0-9]*.*', $_POST, true, false),
          $this->array_scan($elementName.'_[^0-9][0-9]*.*', $_FILES, true, false));
        foreach(array_keys($childrenKeys) AS $key) {
          $res = array();
          if (ereg('('.$elementName.'_)([^0-9_]+).*$', $key, $res)) {
            
            if (!PEAR::isError($e = $this->processFormValue($res[1].$res[2]))) {
              $elements[$res[2]] = $e;
            }
          }
        }
        $result = new SoapObject($elements);
      }
      elseif (array_key_exists($elementName, $_FILES)) {
        if (is_array($finfo = $_FILES[$elementName]) && !$finfo['error'] && $finfo['tmp_name'] && is_uploaded_file($finfo['tmp_name'])) {
          $result = new SoapBinary($finfo['name'], $finfo['type'], null, $finfo['tmp_name']);
        }
        else {
          $result = '';
        }
      }
      else {
        // simple type
        $result = array_get_value($elementName, $_POST);
      }
      $this->formCache[$elementName] = $result;
    }
    return $this->formCache[$elementName];
  } // processFormValue()

  function array_scan($keyPattern, &$array, $useRegex = true, $returnFirstMatch = true) {
    if (!$returnFirstMatch) {
      $result = array();
    }
    foreach(array_keys($array) AS $key) {
      if (  (!$useRegex && strpos($key, $keyPattern) === 0)
          ||(ereg($keyPattern, $key))) {
        if ($returnFirstMatch) {
          return $array[$key];
        }
        else {
          $result[$key] = $array[$key];
        }
      }
    }
    return ($returnFirstMatch ? false : $result);
  } // array_scan()

  function isSequence($elementName) {
    return ($this->array_scan($elementName.'_[^0-9-]+', $_POST) !== false);
  } // isSequence()

  function isArray($elementName) {
    return ($this->array_scan($elementName.'_[0-9-]+', $_POST) !== false);
  } // isArray()
  
  function arrayName($elementName) {
    return ereg_replace('_[0-9-][0-9]*$', '', $elementName);
  } // arrayName()

} // class MoodleSoapClientTestForm
?>
