<?php
include_once('soap/SoapServerProxy.php');
include_once('soap/MoodleSoapClasses.php');
include_once('soap/MoodleSoapSerializerFactory_Server.php');

if (defined('SOAP_DEBUG') && SOAP_DEBUG) {
  if (array_key_exists('example', $_GET)) {
    define('SOAP_DEFAULT_CALLBACK', true);
  }
  else {
    define('SOAP_DEFAULT_CALLBACK', false);
  }
}
else {
  define('SOAP_DEFAULT_CALLBACK', false);
}
  
class MoodleSoapServerProxy extends SoapServerProxy {
  function MoodleSoapServerProxy() {
    $this->SoapServerProxy('http://lms.hu-berlin.de/moodle');
  } // MoodleSoapServerProxy()

  function getCourses(&$args) {
      include_once('moodle/MoodleSoapCallback.php');
      if (is_callable(array('MoodleSoapCallback', 'getInstance'))) {
        $obj =& MoodleSoapCallback::getInstance();
      }
      else {
        $obj = new MoodleSoapCallback();
      }
    $params = array(
      'conditions' => MoodleSoapArrayOfCondition::deserialize(array_get_value('conditions', $args))
    );
    $result =& $obj->getCourses($params['conditions']);

    if (PEAR::isError($result)) {
      if (!defined('SOAP_DEBUG') || !SOAP_DEBUG) {
        $result->backtrace = null;
      }
      $this->setFault($result);
      return $result;
    }
    return array(
      'courses' => MoodleSoapArrayOfCourse::serialize($result, 'courses')
      );
  } // getCourses()

  function getCategories(&$args) {
      include_once('moodle/MoodleSoapCallback.php');
      if (is_callable(array('MoodleSoapCallback', 'getInstance'))) {
        $obj =& MoodleSoapCallback::getInstance();
      }
      else {
        $obj = new MoodleSoapCallback();
      }
    $params = array(
      'conditions' => MoodleSoapArrayOfCondition::deserialize(array_get_value('conditions', $args))
    );
    $result =& $obj->getCategories($params['conditions']);

    if (PEAR::isError($result)) {
      if (!defined('SOAP_DEBUG') || !SOAP_DEBUG) {
        $result->backtrace = null;
      }
      $this->setFault($result);
      return $result;
    }
    return array(
      'categories' => MoodleSoapArrayOfCategory::serialize($result, 'categories')
      );
  } // getCategories()

} // class MoodleSoapServerProxy
?>
