<?php 
/* class SoapAttachment
 *
 * Copyright (C) 2005 Christoph Soergel (csoergel@gmx.net)
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * For more information, comments or bug reports: Please refer to
 * http://pr17.net or write to csoergel@gmx.net
 */
include_once('SOAP/Value.php');

class SoapAttachment extends SOAP_Attachment {

  function SoapAttachment($name, $path, $fileName = '', $mimeType = 'application/octet-stream', $content = null, $encoding) {
    if ($content == null) {
      $content = file_get_contents($path);
    }
    $this->SOAP_Attachment($name, $mimeType, null, $content);
    
    $this->options['attachment']['encoding']    = $encoding;
    $this->options['attachment']['disposition'] = ($fileName ? $fileName : basename($path));
  } // SoapAttachment()
 
} // class SoapAttachment
?>
