<?php
include_once ('soap/SoapObject.php');
include_once ('soap/SoapAttachment.php');

class SoapBinary extends SoapObject {
  var $name,
      $path,
      $type,
      $content;
      
  function SoapBinary($name, $type = 'application/octet-stream', $content = null, $path = '', $encoding = 'binary') {
    $this->name     = $name;
    $this->type     = $type;
    $this->content  = $content;
    $this->path     = $path;
    $this->encoding = $encoding;
  } // SoapBinary()
  
  /* PUBLIC STATIC SoapBinary & */ function & deserializeXmlStruct(&$xmlStruct) {
    if (!is_object($xmlStruct) || 
        !isset($xmlStruct->name) || 
        !isset($xmlStruct->content) || 
        !isset($xmlStruct->type) ||
        !isset($xmlStruct->encoding) 
        ) {
      return (_SOAP_VALIDATE_INPUT ? new PEAR_Error('error in message deserialization: binary expected, got "'.$xmlStruct.'" instead') : new SoapBinary(null));
    }
    return new SoapBinary(object_get_value('name', $xmlStruct), object_get_value('type', $xmlStruct), object_get_value('content', $xmlStruct), object_get_value('encoding', $xmlStruct));
  } // deserializeXmlStruct()

  /* PUBLIC STATIC SOAP_Value & */ function & serializeObj(&$obj, $resultName = '') {
    if (!is_object($obj) || 
        !isset($obj->name) || 
        !(isset($obj->content) || (isset($obj->path) && is_readable($obj->path))) ||
        !isset($obj->encoding) || 
        !isset($obj->type) ) {
      return (_SOAP_VALIDATE_OUTPUT ? new PEAR_Error('error in message serialization: binary expected, got "'.$obj.'" instead') : new SOAP_Value($resultName, '{http://www.w3.org/2001/XMLSchema}', ''));
    }
    return new SoapAttachment($resultName, object_get_value('path', $obj), object_get_value('name', $obj), object_get_value('type', $obj), object_get_value('content', $obj), object_get_value('encoding', $obj));
  } // serializeObj()

} // class SoapBinary
?>
