<?php
/* class    SoapClientProxy
 * package  soap
 *
 * Copyright (C) 2005 Christoph Soergel (csoergel@gmx.net)
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * For more information, comments or bug reports: Please refer to
 * http://pr17.net or write to csoergel@gmx.net
 */
include_once('SOAP/Client.php');
include_once('soap/soaputils.php');

class SoapClientProxy extends SOAP_Client {
  var $rrtime, $client, $error; 

  function SoapClientProxy($endpoint, $proxyParams = null) {
    $this->error  = NULL;
    $this->client = new SOAP_Client($endpoint, null, null, $proxyParams);
    $this->client->__use('literal');
    $this->client->__options['attachments'] = 'Mime';
    $this->client->__options['timeout']     = 30;
    if (defined('SOAP_DEBUG') && SOAP_DEBUG) {
      $this->client->__trace(true);
    }
  } // SoapClientProxy()

  function & getLastRequest($truncateAttachments = true) {
    $r = (defined('SOAP_DEBUG') && SOAP_DEBUG ? $this->debugOutput($this->client->__getlastrequest(), array_get_value('headers', $this->client->__options), $truncateAttachments) : 'SOAP_DEBUG disabled');
    return $r;
  } // getLastRequest()

  function & getLastResponse($truncateAttachments = false) {
    $r = (defined('SOAP_DEBUG') && SOAP_DEBUG ? $this->debugOutput($this->client->__getlastresponse(), $this->client->_soap_transport->result_headers, $truncateAttachments) : 'SOAP_DEBUG disabled');
    return $r;
  } // getLastResponse()

  function debugOutput($str, $headers, $truncateAttachments = false) {
    ($truncateAttachments && is_array($headers) &&
        (($ct = array_get_value('Content-Type', $headers)) || ($ct = array_get_value('content-type', $headers)))  &&
        ereg('boundary="([^"]*)"', $ct, $rr) && count($rr) > 1 &&
        $boundary = $rr[1])
    || $boundary = null;
    return $str;
  } // debugOutput()

  function & _soapcall($name, &$params, $options) {
    if (defined('SOAP_DEBUG') && SOAP_DEBUG) {
      $requestStartMS = microtime();
    }
    if (PEAR::isError($result =& $this->client->call($name, $params, $options))) {
      $this->error = $result;
    }
    if (defined('SOAP_DEBUG') && SOAP_DEBUG) {
      // soap_client_log_request($this->getLastRequest(true));
      // soap_client_log_response($this->getLastResponse(true));
      // $this->rrtime = Benchmark::timeDiff($requestStartMS, microtime(), false);
    }
    return $result;
  } // _soapcall()

} // class SoapClientProxy
?>
