<?php
/* class SoapObject 
 *
 * Copyright (C) 2005 Christoph Soergel (csoergel@gmx.net)
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * For more information, comments or bug reports: Please refer to
 * http://pr17.net or write to csoergel@gmx.net
 */

class SoapObject {

  function SoapObject($values) {
    foreach($values AS $key => $value) {
      $this->$key = $value;
    }
  } // SoapObject()

  function getValue($key) {
    return $this->$key;
  } // getValue()

  function setValue($key, $value) {
    $this->$key = $value;
  } // setValue()

  function castSimpleType($type, $value, $validate) {
    $value = trim($value);
    switch ($type) {
      /* buildIn / XML Schema */ 
      case 'string':
        $rv = $value.'';
        $valid = ($rv === $value);
        break;
      case 'int':
        $rv = trim($value) * 1;
        $valid = ($rv == $value);
        break;
      case 'boolean':
        $rv = !(!$value);
        $valid = ($rv == $value);
        break;
      case 'double':
        $rv = $value * 1.0;
        $valid = ($rv === $value);
        break;
      // TODO: validation!
      case 'date':
      case 'dateTime':
      case 'time':
        $rv = $value;
        $valid = true;
        break;
    }
    if ($validate && !$valid) {
      return new PEAR_Error('type mismatch: '.$type.' expected, got '.$value.' instead');
    }
    return $rv;
  } // castSimpleType()

} // class SoapObject
?>
