<?php
define('_SOAP_SERVER', 0);
define('_SOAP_CLIENT', 1);
define ('_SOAP_VALIDATE_INPUT', (defined ('SOAP_VALIDATE_INPUT') && SOAP_VALIDATE_INPUT ? true : false));
define ('_SOAP_VALIDATE_OUTPUT', (defined ('SOAP_VALIDATE_OUTPUT') && SOAP_VALIDATE_OUTPUT ? true : false));

function & object_get_value($key, &$obj) {
  if (isset($obj->$key)) {
    return $obj->$key;
  }
  return null;
} // object_get_value()

function & array_get_value($key, &$array) {
  if (array_key_exists($key, $array)) {
    return $array[$key];
  }
  $r = null;
  return $r;
} // array_get_value()


function soap_log_enabled($scflag = _SOAP_SERVER) {
  static $enabled;
  if (!is_array($enabled))
    $enabled = array();
  if (!isset($enabled[$scflag])) {
    $enabled[$scflag] = (defined('SOAP_DEBUG') ? SOAP_DEBUG : false);
  }
  return $enabled[$scflag];
} // soap_log_enabled()

function soap_server_log_request($str) {
  if (soap_log_enabled(_SOAP_SERVER)) {
    file_append(SOAP_REQUEST_LOGFILE, $str);
  }
} // soap_server_log_request()

function soap_server_log_response($str) {
  if (soap_log_enabled(_SOAP_SERVER)) {
    file_append(SOAP_RESPONSE_LOGFILE, $str);
  }
} // soap_log_server_response()

function soap_client_log_request($str) {
  if (soap_log_enabled(_SOAP_CLIENT)) {
    file_append(SOAP_REQUEST_LOGFILE, $str);
  }
} // soap_client_log_request()

function soap_client_log_response($str) {
  if (soap_log_enabled(_SOAP_CLIENT)) {
    file_append(SOAP_RESPONSE_LOGFILE, $str);
  }
} // soap_log_client_response()

function file_append($filename, $str) {
  if ($filename == NULL) return;
  if ($fp = fopen($filename, 'a')) {
    fwrite($fp, $str);
    fclose($fp);
  }
} // file_append()

function xmlentities ($str) {
  return htmlspecialchars ($str);
} // xmlentities ()

function timeDiff($start, $stop, $asArray = true) {
  $_start = explode(' ', $start);
  $_stop  = explode(' ', $stop);

  $startS  = $_start[1];
  $startMs = $_start[0] * 1000;

  $stopS  = $_stop[1];
  $stopMs = $_stop[0] * 1000;

  if ($stopMs < $startMs) {
    $stopMs += 1000;
    --$stopS;
  }
  if (!$asArray) {
    return round((($stopS - $startS) * 1000 + round($stopMs - $startMs, 0)) / 1000, 4);
  }
  return array('s' => ($stopS - $startS),
	 'ms' => ($stopMs - $startMs));
} // timeDiff()
?>
